;
;Ampel "Merf"
; fr Auto Steht auf grn und fr Fugnger auf rot
; mensch drck
; Ampel geht fr Mensch auf grn und fr Auto fr 5 sec.
; und springt dann wieder auf normal status um
;
;autoamp        grn    /       gelb    /       rot     /       rot, gelb       /       grn
;fuamp         rot     /       rot     /       grn    /       rot             /       rot
;


;        Ports auf ausgang schalten
;        timer einstellen, interrups aktivieren, vergleichswert setzten
;        Auto gruen schalten, Fusgaenger rot
;
; Do
;        Wenn Taster nicht gedrueckt, back to Anfang
;        Wenn Taster gedrueckt. warten.
;        Wenn warten um, AUto gelb, fus rot
;        warten
;        auto rot, fus grn
;        warten
;        auto rot, gelb, fus rot
;        warten
;        auto grn, fus rot
;        back to the future
;
; LOOP
;
;SLELFNOT
;TCNT1 wird automatishc immer erhoehr
;OCR1A hier kommt der wert zum vergleichen rein
; fuer 2c warten, vergleichswert = 7200 bei einem prescaler von 1024


.include "m8def.inc"

.def temp      = r16
.def timefertig = r17

.equ autorot   = 0
.equ autogelb  = 1
.equ autogruen = 2
.equ fusrot    = 3
.equ fusgruen  = 4

.equ taster    = 2

.equ LEDOUT    = PORTB
.equ TASTERIN    = PIND


;------------------------------------------------------------------------
;Reset and Interruptvectoren	;VNr.	Beschreibung
begin:	rjmp	main	;1     POWER ON RESET

.org    OC1Aaddr
	rjmp	comparematch ;7 TC1 Compare Match A
;------------------------------------------------------------------------

main:
        ldi temp, LOW(RAMEND)
        out SPL, temp
        ldi temp, HIGH(RAMEND)
        out SPH, temp

;       PORTB Als ausgang
        ldi temp, 0b11111111
        out DDRB, temp

        ; Pullups PORTD
        out PORTD, temp

        ; Vergleichswert setzen
        ldi temp, BYTE1(7200)
        out OCR1AH, temp
        ldi temp, LOW(7200)
        out OCR1AL, temp

        ; Output Compare Interrupt Register 1A Enable                        ;
        ; Timer Overflow Interrupt Enable 1
        ldi temp, 1 << OCIE1A
        out TIMSK, temp

        ; Interrupts einschalten
        sei

mainloop:

;         auto grn, fus rot
         ldi temp, 1 << autogruen | 1 << fusrot
         out LEDOUT, temp

;        Wenn Taster nicht gedrueckt, back to Anfang
        sbic TASTERIN, taster
        rjmp mainloop

;        Wenn Taster gedrueckt. warten.
        rcall starttimer
        rcall warten
;        Wenn warten um, Auto gelb, fus rot

        ldi temp, 1 << autogelb | 1 << fusrot
        out LEDOUT, temp

        rcall starttimer
        rcall warten

;        auto rot, fus grn
        ldi temp, 1 << autorot | 1 << fusgruen
        out LEDOUT, temp

        rcall starttimer
        rcall warten
;        auto rot, gelb, fus rot
        ldi temp, 1 << autorot | 1 << autogelb | 1 << fusrot
        out LEDOUT, temp

        rcall starttimer
        rcall warten

	rjmp	mainloop

warten:
        tst timefertig
        breq warten
        ret

starttimer:

        clr timefertig
        out TCNT1H, timefertig
        out TCNT1L, timefertig
        ldi temp, (1 << CS10) | (1 << CS12)
        out TCCR1B, temp
ret

comparematch:

        clr temp
        out TCNT1L, temp
        out TCNT1H, temp
        ldi timefertig, 1
        out TCCR1B, temp

        reti
